Subject: Re: [PATCH] git-p4: support exclusively locked files

From: Pete Wyckoff <[email-masked]>
Date: Sun, 17 Mar 2013 16:04:37 -0400

[email-masked] wrote on Wed, 13 Mar 2013 13:51 -0400:
> By default, newly added binary files are exclusively locked by Perforce:
> 
> 'add default change (binary+l) *exclusive*'
> 
> This results in a 'Could not determine file type' error as the regex
> expects
> the line to end after the file type matching group. Some repositories are
> also configured to always require exclusive locks, so may be a problem for
> all revisions in some cases.

Can you explain how to configure p4d to default everything to
binary+l?  Also, what version are you using ("p4 info")?  I'm
trying to write a test case for this.

I did find a way to play with typemap to get +l, as:

    ( p4 typemap -o ; printf "\tbinary+l\t//.../bash*" ) | p4 typemap -i

With this, the 2011.1 here just says:

    tic-git-test$ p4 opened bash
    //depot/bash#1 - add default change (binary+l)

I've not been able to make it say " *exclusive*" too.

>      result = p4_read_pipe(["opened", wildcard_encode(file)])
> -    match = re.match(".*\((.+)\)\r?$", result)
> +    match = re.match(".*\((.+)\)(?:.+)?\r?$", result)

I think this whole function would be less brittle
using p4's "-G" output, like:

    d = p4Cmd(["fstat", "-T", "type", wildcard_encode(file)])
    # some error checking
    return d['type']

But I'm curious if your p4d includes " *exclusive*" in the
type there too, in which case we'll have to strip it.

Thanks for starting the patch on this.  It's good if we can keep
others from running into the same problem.

		-- Pete